Added new checks and removed unnecessary code in bldpkg

This commit is contained in:
PktSurf 2022-09-25 22:25:51 +05:30
parent 44b81f703b
commit af90213c2a

73
bldpkg
View file

@ -109,6 +109,13 @@ else
exit 1
fi
# Error out if globalccache and globalsccache are set in the /etc/bldpkg.conf
if [[ $globalccache = 1 ]] && [[ $globalsccache = 1 ]] ; then
echo "[ERROR] Please only enable either ccache or sccache in /etc/bldpkg.conf"
echo "[ERROR] at the same time, not both."
exit 1
fi
# Function to validate the build file.
validatebldfile() {
local buildfile
@ -318,8 +325,7 @@ if [[ $genchecksum = 1 ]] ; then
files=( *.tar.* *.zip *.t?z *.patch *.diff *.c *.h )
# For loop that searches for files matching the above extension
# and prints them to the bottom of the build file
# For loop that searches for files matching the above extension and prints them to the bottom of the build file
for file in "${files[@]}" ; do
if [[ -f $file ]] ; then
sha512sum "$file" >> "$buildfile"
@ -477,13 +483,6 @@ fi
# Discard the test file
[[ -e "$parenttmp/.smlinuxwritetest" ]] && rm -f "$parenttmp/.smlinuxwritetest"
# Determine if $tmpfsdir is listed inside $protecteddirectories array
if inarray "${parenttmp}" "${protecteddirectories[@]}" ; then
echo "############ ATTENTION ############"
echo "[ERROR] parenttmp VARIABLE IS SET TO '$tmpfsdir' WHICH IS A PROTECTED DIRECTORY!! EXITING!!"
exit 1
fi
# If htmloutput is set to 1, echo $app, $version and $build as file names inside the parent build directory.
# This will output into an HTML file so that the basic status of the build process (whether started, stopped,
# interrupted or failed) can be viewed in the web browser.
@ -505,7 +504,7 @@ fi
# Validate compressor and set extension
validpkgextensions=( tgz tbz tlz txz )
if ! inarray "${pkgext}" "${validpkgextensions[@]}" ; then
echo "[ERROR] '$pkgext' is not a valid package extension for an SMLinux installer file."
echo "[ERROR] '$pkgext' is not a valid pkg extension for an SMLinux installer file."
exit 1
fi
@ -596,7 +595,6 @@ if [[ $usetmpfs = 1 ]] && [[ -n $tmpfsdir ]] && [[ -z $tmpfscheckfailed ]] ; the
# In the absence of tmpfs, we use the normal directory
tmp="$nontmpfsdir/$app.src"
readonly pkg
pkg="${pkg:-$nontmpfsdir/package-$app}"
else
# We compile inside tmpfsdir. Set the tmpfsenabledforthispackage variable here to inform build
@ -622,6 +620,20 @@ else
pkg=${pkg:-$nontmpfsdir/package-$app}
fi
if inarray "${pkg}" "${protecteddirectories[@]}" ; then
echo "############ ATTENTION ############"
echo "[ERROR] 'pkg' VARIABLE IS SET TO '$pkg' WHICH IS A PROTECTED DIRECTORY! EXITING!"
exit 1
fi
# Also check tmp directory in advance
if inarray "${tmp}" "${protecteddirectories[@]}" ; then
echo "############ ATTENTION ############"
echo "[ERROR] 'tmp' VARIABLE IS SET TO '$tmp' WHICH IS A PROTECTED DIRECTORY! EXITING!"
exit 1
fi
# Validate and export $cputhreads as MAKEFLAGS variable
if [[ -n $cputhreads ]]; then
# export the user-defined number
@ -798,6 +810,7 @@ fi
# Validate everything related to sccache if globalccache is set
if [[ $globalsccache = 1 ]]; then
if [[ ! -x $sccachebinpath ]] ; then
echo "[ERROR] Oops! sccache binary was not found but building with it"
echo "[ERROR] was requested! Either ensure sccache is in your "'$PATH'" or"
@ -959,14 +972,8 @@ mkandenterbuilddir() {
pkgdocs="$pkg/share/doc/$app-$version"
# Remove any old pkg staging directory left by any previous build having same application name
if ! inarray "${pkg}" "${protecteddirectories[@]}" ; then
rm -rf "$pkg"
else
echo "############ ATTENTION ############"
echo "[ERROR] 'pkg' VARIABLE IS SET TO '$pkg' WHICH IS A PROTECTED DIRECTORY! EXITING!"
exit 1
fi
rm -rf "$pkg"
# Now create all essential build-related directories
mkdir -p "$tmp" "$pkg/install" "$pkgdocs" "$pkgdest"
@ -1228,6 +1235,12 @@ EOF
# Terminate auditd daemon
terminateauditd
# Terminate sccache
if [[ $globalsccache = 1 ]] ; then
echo "[INFO] Terminating sccache"
/bin/sccache --stop-server
fi
echo "[INFO] Leaving staging directory $pkg"
@ -1271,24 +1284,12 @@ EOF
# Delete the build directory if preservebuilddir is set to 0
if [[ $preservebuilddir = 0 ]] ; then
if ! inarray "${tmp}" "${protecteddirectories[@]}" ; then
rm -rf "$tmp"
else
echo "############ ATTENTION ############"
echo "[ERROR] 'tmp' VARIABLE IS SET TO '$tmp' WHICH IS A PROTECTED DIRECTORY! EXITING!"
exit 1
fi
rm -rf "$tmp"
fi
# Delete the package staging directory if preservepackagedir is set to 0
if [[ $preservepackagedir = 0 ]] ; then
if ! inarray "${pkg}" "${protecteddirectories[@]}" ; then
rm -rf "$pkg"
else
echo "############ ATTENTION ############"
echo "[ERROR] 'pkg' VARIABLE IS SET TO '$pkg' WHICH IS A PROTECTED DIRECTORY! EXITING!"
exit 1
fi
rm -rf "$pkg"
fi
}
@ -1585,6 +1586,12 @@ interruptoutput() {
# Terminate auditd daemon
terminateauditd
# Terminate sccache
if [[ $globalsccache = 1 ]] ; then
echo "[INFO] Terminating sccache"
/bin/sccache --stop-server
fi
# If installprompt and extractprompt are set and the prompt is invoked after a successful build, hitting
# ctrl-C will only set the above sm variable repeatedly and won't return user to the shell because
# of the interrupt (SIGINT) trap set way below. Putting exit 0 is a decent way to get out of that prompt